﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XDGComboDependentValues
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        public List<string> ComboData1 { get; set; }
        public List<string> ComboData2 { get; set; }


        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            ComboData1 = new List<string>();
            ComboData2 = new List<string>();

            for(int i=0; i<10; i++)
            {
                string c1Str = "Combo Item A" + i.ToString();
                string c2Str = "Combo Item B" + i.ToString();

                SampleData sd = new SampleData()
                {
                    ID = i,
                    Combo1 = c1Str,
                    Combo2 = c2Str,
                    Number = r.Next(1000)
                };

                ComboData1.Add(c1Str);
                ComboData2.Add(c2Str);

                Data.Add(sd);
            }

        }
    }

    public class SampleData : ObservableModel
    {
        private string _combo1;
        private string _combo2;


        public int ID { get; set; }
        public string Combo1
        {
            get { return _combo1; }
            set
            {
                _combo1 = value;
                NotifyPropertyChanged();
            }
        }

        public string Combo2
        {
            get { return _combo2; }
            set
            {
                _combo2 = value;
                NotifyPropertyChanged();
            }
        }

        public int Number { get; set; }
    }

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
